world
	name = "2280"
	hub = "Anthony7.2280"
	turf = /turf/grass



mob
	var
		maxhp
		hp
		maxmp
		mp
		lvl
		gold = 0
		str
		def
		agi
		int
		lck
		exp
		maxexp
		pdefence = 0 // percentage of physical damage taken off
		mdefence = 0 // percentage of magical damage taken off

		expgive
		list/skills = newlist()
		dead
		Muted
		logged
		inaction
		lock
		race

		lastx
		lasty
		lastz
		inbattle
		monstermove




		mob/newchar

	human // short and sweet classes
		icon = 'HumanWhite.dmi'
		race = "Human"
		lvl = 1
		maxhp = 30
		maxmp = 0
		str = 14
		def = 12
		int = 9
		agi = 10
		lck = 35
		exp = 0
		maxexp = 20

		skills = newlist(/battle/battleskill/bighit) // skills included

	bright
		icon = 'BrightWhite.dmi'
		race = "Bright"
		lvl = 1
		maxhp = 20
		maxmp = 70
		str = 7
		def = 9
		int = 24
		agi = 16
		lck = 25
		exp = 0
		maxexp = 20

		skills = newlist(/battle/battleskill/wave,/battle/battleskill/blast)

	Login()
		if(src.logged) // only do this if you have a char already in
			..()
			src.Relocate()
			src.Regenerate()

			world << "<small><font color = blue><b>[src] logs in."

			src << "Welcome to 2280, we are currently in Version 1"

		else // straightforward login
			var/list/classlist = list("Human","Bright")
			var/cclass = input(src, "Pick a class","2280") in classlist
			switch(cclass)
				if("Bright") src.newchar = new /mob/bright ()
				if("Human")  src.newchar = new /mob/human  ()
			newchar.name = src.key
			newchar.logged = 1
			new /item/potion (newchar) // start off with those
			new /item/ether (newchar)
			src.client.mob = newchar
			del(src)

	Logout()
		if(src.logged)
			world << "<small><font color = red><b>[src] logs off."
			del(src)
			..()

	Stat() // sweet and simple statpanel
		if(src.logged)
			if(statpanel("Statistics"))
				stat(src)
				stat("Level: ","[usr.lvl]")
				stat("Experience: ","[usr.exp]/[usr.maxexp]")
				stat("HP:    ","[src.hp]/[src.maxhp]")
				stat("Energy:    ","[src.mp]/[src.maxmp]")
				stat("Strength: ",src.str)
				stat("Defence: ",src.def)
				stat("Intelligence: ",src.int)
				stat("Agility: ",src.agi)
				stat("Luck: ",src.lck)
				stat("")
				stat("Gold: ",src.gold)
				stat(null)
			if(statpanel("Skills"))
				stat("Skills:", null) // skills are shown here so when you click on it, your macro will turn to it
				if(src) stat(src.skills)
			if(statpanel("Inventory"))
				stat("Inventory:", null)
				if(src) stat(src.contents)

	Move()
		if(src.lock) return

		if(..()) // only randomencounter when you actually moved
			if(src.monstermove)
				var/monsterspawn/S = new src.monstermove
				if(S)
					if(prob(S.spawnchance)) // chance on this
						var/battlefield/A
						for(var/battlefield/b in world)
							if(b.fieldtype==S.fieldtype)
								if(!b.inuse)
									A = b // only pick the first one
									break
						if(A)
							var/list/MonList = S.monsterspawnlist
							var/thattype = pick(MonList) // pick one of the monsters the monsterspawn can spawn up
							var/mob/monsters/M = new thattype // create the mob
							src.lastx = src.x // save those necessary variables
							src.lasty = src.y
							src.lastz = src.z
							src.loc = A.loc
							src.lock = 1
							M.lock = 1
							M.loc = A.loc // move them to their positions
							src.y -= 2
							M.y += 2
							src.dir = NORTH // set their directions
							M.dir = SOUTH
							src.inbattle = 1 // put the in battle
							M.inbattle = 1

							new /battle_sorters (A.loc, src, M) // and away we go, this object controls the battle


	proc
		DeathCheck(mob/M)
			if(src.hp<=0)
				src.dead = 1
				return 1
			else
				return 0

		Regenerate()
			src.hp = src.maxhp
			src.mp = src.maxmp
			src.dead = 0

		Relocate()
			src.loc = locate(/area/respawn)

proc
	luckchance(mob/M)
		var/chance = rand(1,100)
		if(chance<=M.lck) // lower your luck, worse the chance
			return 1
		else
			return 0


client
	Northwest() return  // disable all diagonal directions
	Northeast() return
	Southwest() return
	Southeast() return


area
	respawn
		Enter() return 1 // you are always able to enter the respawn

	monsterspawn
		var/monsterspawn/G
		Entered(atom/movable/A)
			if(ismob(A))
				var/mob/M = A
				if(M.client)
					M.monstermove = G // set your monstermove variable to it
		Exited(atom/movable/A)
			if(ismob(A))
				var/mob/M = A
				if(M.client)
					M.monstermove = null // can't be in a monster area forever

		squints
			G = /monsterspawn/squints

/*		guards
			G = /monsterspawn/guards


		boss
			G = /monsterspawn/boss
*/

turf                        // sweet and simple turfs 'n objects
	icon = 'turfs.dmi'
	wall
		icon_state = "wall"
		density = 1
	walledge
		icon_state = "walledge"
		density = 1
	water
		icon_state = "water"
		density = 1
	grass
		icon_state = "grass"
	sand
		icon_state = "sand"
	woodfloor
		icon_state = "woodfloor"

	void
		icon_state = "black"
		density = 1
		opacity = 1

	regeneration_pad
		icon_state = "regen"
		Entered(atom/movable/A) // this is just for testing purposes
			if(ismob(A))
				var/mob/M = A
				M.Regenerate()
				M << "You have been regenerated to full health!"

obj
	icon = 'turfs.dmi'
	rock
		icon_state = "rock"
		density = 1
	tree
		icon_state = "tree"
		density = 1


battlefield
	parent_type = /obj
	var/inuse = 0
	var/fieldtype = "none"

	desert
		fieldtype = "desert"

	grasslands
		fieldtype = "grasslands"

	bossland
		fieldtype = "bossland"

item      // hey, since there are item capabilities in the battlefield, why don't we add potions?
	parent_type = /obj
	icon = 'items.dmi'
	proc									  ////
		Use(mob/M)							//
			view(M) << "[M] uses \an [src]."//////////////////////////////////////////
			sleep(10)						//										//
											  ////									//
																					//
		BattleUse()																	//
																					//
	Click()																			//
		if(src in usr.contents)														//
			if(!usr.inbattle)														//
				src.Use(usr)														//
																					//
                                                                                    //
	potion                                                                          //
		icon_state = "potion"                                                       //
		Use(mob/M)                                                                  //
			..() // incase you didn't know, ..() calls the original Use() proc so this is called
			view(M) << "[M] recovered 25 health points."
			M.hp += 25
			if(M.hp > M.maxhp) M.hp = M.maxhp
			del(src)
		BattleUse(mob/M)
			view(M) << "[usr] uses a [src]."
			sleep(10)
			view(M) << "[M] recovered 25 health points."
			M.hp += 25
			if(M.hp > M.maxhp) M.hp = M.maxhp
			del(src)
	ether
		icon_state = "ether"
		Use(mob/M)
			..()
			view(M) << "[M] recovered 20 energy points."
			M.mp += 25
			if(M.mp > M.maxmp) M.mp = M.maxmp
			del(src)
		BattleUse(mob/M)
			view(M) << "[usr] uses an [src]."
			sleep(10)
			view(M) << "[M] recovered 25 energy points."
			M.mp += 25
			if(M.mp > M.maxmp) M.mp = M.maxmp
			del(src)





